/**
 * DIS Header database  manipulations(dis header table)
 */
package pduDB;

import java.sql.*;
import java.util.*;


import mil.navy.nps.dis.*;
import mil.navy.nps.util.*;
import mil.navy.nps.disEnumerations.*;



public class DISHeaderDML {

 private ProtocolDataUnit pdu;
 private SQLUtil db; //db connection
 private static String tablename = "dis_header_table";

 private static String[] header_cols = {
        "id","distimestamp","pdutype","protocolversion",
        "exerciseid","protocolfamily"};

 private static String qMarks = "?,?,?,?,?";
 private String insertSql = "insert into " + tablename;

 private Hashtable ht;
 private int headerId = -1;
 
 public DISHeaderDML(SQLUtil dbUtil){
     pdu = null;
     db = dbUtil;
 }
 public DISHeaderDML(ProtocolDataUnit pu, SQLUtil dbUtil) {
     pdu = pu;
     db = dbUtil;
     fillHash();
 }

 public DISHeaderDML(ProtocolDataUnit aPdu, Hashtable pht, SQLUtil dbUtil) {
     pdu = aPdu;
     db = dbUtil;
     ht = pht;
     fillPdu();
 }

 private void fillHash(){
     ht = new Hashtable();
     ht.put("distimestamp",pdu.getTimestamp().toString());
     ht.put("pdutype",pdu.getPduType().toString());
     ht.put("protocolversion",pdu.getProtocolVersion().toString());
     ht.put("exerciseid",pdu.getExerciseID().toString());
     ht.put("protocolfamily",pdu.getProtocolFamily().toString());
  //   System.out.println("HT in fill hash = "+ ht.toString());
 
 }

 private void fillPdu() {
     try{
         headerId = Integer.parseInt(ht.get("id").toString());
         pdu.setProtocolVersion(Integer.parseInt(ht.get("protocolversion").toString()));
         pdu.setExerciseID(Integer.parseInt(ht.get("exerciseid").toString()));
         pdu.setPduType(Short.parseShort(ht.get("pdutype").toString()));
         pdu.setProtocolFamily(Integer.parseInt(ht.get("protocolfamily").toString()));
         pdu.setTimestamp(Long.parseLong(ht.get("distimestamp").toString()));
     }catch(Exception e) {msg(e.getMessage());}   
 }
 public void save(){
     insertSql = makeSQLStr(insertSql);
     //msg("Inserted on PDU...");
     try {
         db.insert(ht,tablename,insertSql,1); 
         headerId = Integer.parseInt(db.getMaxValue(tablename,"id"));
//         System.out.println("header table id = " + headerId);
     }catch(Exception e) {
         msg("Error ! while getting Entity State Record Id ");
         msg(e.getMessage());
     }
 }

 private String makeSQLStr(String s) {
     StringBuffer sb = new StringBuffer(s + "(");
     for(int i = 1; i < header_cols.length; i++) {
         if(i < header_cols.length-1)
	         sb.append(header_cols[i].toLowerCase() +",");
         else
			 sb.append(header_cols[i].toLowerCase() + ")");
     }
     sb.append(" values ( " + qMarks + " ) ");     
     return sb.toString();
 }
 
 public ProtocolDataUnit read(int id){
     
     ProtocolDataUnit pdu = null;
     
     StringBuffer sb = new StringBuffer();
     sb.append(XMLConstants.xmlHeader);
     
     
     return pdu;
 }
 public ProtocolDataUnit getPDU(){
     return pdu;
 }
 public int getId() {
     return headerId;
 }
 

 private void msg(String str) {
     System.out.println(str);
 }
 
}
