/**
 * DISPduPlaybackServlet.java
 * 
 * This servlets plays back DIS PDUs from the
 * database. 
 *
 */
package pduDB;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.*;

import mil.navy.nps.dis.*;
import mil.navy.nps.util.*;
import mil.navy.nps.disEnumerations.*;

import org.w3c.dom.*;
import com.docuverse.freedom.*;

import iwt.domUtil.*;
import iwt.*;
//import printXML;
 
public class DISPduPlaybackServlet extends HttpServlet {

 private static SQLUtil db; //db connection
 private static boolean sendingFlag = false;
 private String sql;
 private Hashtable ht;
 private String dis_tablename = "dis_header_table";
 private String action = "";
 private int entityId = -1;
 private ServletOutputStream out;

 private ProtocolDataUnit[] pduArr;
 private Hashtable[] htArr;
 private int[] timeDiffArr;
 private String mode ="";

 public static final boolean DEBUG = true;

/**
 * Handle the GET HTTP REQUEST Method 
 */

 public void doGet(HttpServletRequest req, HttpServletResponse res)
                    throws IOException {

     res.setContentType("text/html");
     out = res.getOutputStream();
     action = req.getParameter("action");
     if(action == null) { 
//         errMsg("No action parameter present <br> "+
  //              "Usage : http://hostname:portnum/servlet/PduPlayback?action=query&t1=2132232&t2=2342323</body></html>");
         homePage();
         return;
     }
     int intT1=-1, intT2=-1;

     if(action.equals("query")) {
         String t1 = req.getParameter("t1");
         String t2 = req.getParameter("t2");
         String eid = req.getParameter("eid");
         mode = req.getParameter("mode");
         if(t1 == null || t2 == null) {
             errMsg("Starting and ending timestamp parameters required !");
             return;
         }
         if(mode == null || mode.trim().equals("")) {
             mode = "dis";
         }else if(!( mode.equals("dis") || mode.equals("hla"))){
             mode = "dis";
         }
         try{
             intT1 = Integer.parseInt(t1);
             intT2 = Integer.parseInt(t2);
             if(intT1 > intT2) {
                 errMsg("Error! Starting timestamp greater than ending timestamp..");
                 return;
             }   
             sendingFlag = true;
         }catch(Exception e) {errMsg("Wrong type of parameters");msg(e.getMessage());}
         if(eid != null && !(eid.trim().equals(""))) {
             try {entityId = Integer.parseInt(eid);}
             catch(Exception e){ entityId = -1; msg("no Eid present");}
         }
	 out.println("Starting to send the PDU's....."); 
     }else if(action.equals("stop")) {
         sendingFlag = false;
         out.println("Stopping the PDU playback......");
     }else {
         errMsg("Unknown action parameter..!");
         return;
     }
     out.flush();
     out.close();
     if(sendingFlag) doQuery(intT1,intT2);
    
     msg("Inside GET method");
 }
 
 private void homePage(){
     try{
     out.println("<html><title> PDU Playback Servlet </title>");
     out.println("<body bgcolor=white><center><font size=+3 color=teal> DIS-HLA PDU Playback Database </font> </center>");      
     out.println("<hr><p> Enter the  starting time stamp and ending time stamp");
     out.println("<form name=pdu action=/servlet/PduPlayback method=get>");
     out.println("<br><input type=hidden name=action value=query> ");
     out.println("<b>Starting Timestamp :</b><input type=text name=t1 value=68400000 size=10>");
     out.println("<b>Ending Timestamp :</b> <input type=text name=t2 value=68500000 size=10><p>");
     out.println("<b>Mode :</b> <select name=mode><option value=DIS selected>DIS<option value=hla>HLA</select>");
     out.println("<p><center><input type=submit value=Submit><input type=reset value=Cancel></center> <hr>");
     out.println("</form>");
     }catch(Exception e){e.printStackTrace(System.out);}
     
 }
 private void printTag(String tag, String body) { 
 }
 private void doQuery(int t1, int t2){
     sql = "select * from "+dis_tablename +" where (distimestamp between ";  //where distimestamp between ";
     sql = sql+ t1 +" and "+ t2 +" ) and (not(pdutype=25)) order by id";
     doQuery(sql); 
 }
 private void doQuery(String sql ) {

     Hashtable rht = new Hashtable();
     //Vector pduVec = new Vector();
     //ProtocolDataUnit aPdu = null;
     int i = 0,total =0;
     PduSender pduSender;
     msg("going to check the mode ="+ mode);
     if(mode.equals("hla")) {
         pduSender = new HLAPduSender();
         msg("Sending in HLA mode ");
     }
     else {
         pduSender = new DISPduSender();
         msg("Sending in DIS mode ");
     }

     

     Vector v = db.getMultiRecords(sql);
     total = v.size();
     htArr = new Hashtable[total];
     timeDiffArr = new int[total];

     msg("Vector size = "+total);
     
     for (Enumeration e = v.elements() ; e.hasMoreElements() ;) {
         htArr[i] = (Hashtable)e.nextElement();
          i++;
     }
  //   timeDiffArr[0] = 0;
     ProtocolDataUnit sPdu;
     short j = 0;
     for(i=0; i<htArr.length;i++) {
       // j = Short.parseShort(htArr[i].get("pdutype").toString());
        //if(j == 1 || j == 175 || j == 176 || j == 2 || j == 3 ) {
            
            if( i < total-1 ) 
                 setTimeDiffArr(i,htArr[i].get("distimestamp").toString(),
                     htArr[i+1].get("distimestamp").toString());
            sPdu = getPDU(htArr[i]);
            if(i <= timeDiffArr.length)
                try { Thread.sleep(timeDiffArr[i]);}catch(Exception e){}
            //j = sPdu.getPduType().shortValue();
            if(sendingFlag) {
                pduSender.send(sPdu);
            }else{
                pduSender.stop();
                break;
            }
       //  }
         System.out.println("sending pdu # "+i + " after "+timeDiffArr[i] + " seconds");
     }
     msg("Finished setting their times");
     
     msg("Finished producing PDU's.........");
  //   try {
    // out.println("Send "+total + " # of PDU's");
     //}catch(Exception e){msg("could not write to socket");}
    
 }
 private void setTimeDiffArr(int idx,String t1, String t2) {
     int time1, time2, diff = 0;
     try {
         time1 = Integer.parseInt(t1);
         time2 = Integer.parseInt(t2);
       //  System.out.println("i="+idx+"time1="+time1+" time2="+time2);
         diff = time2 - time1;
         if(diff < 0) {
             diff = 0;
         }else if (diff > 999) {
             diff = 500;
         }
         System.out.println("diff = "+diff);
         if(mode.equals("hla")) diff = diff +1000;
         timeDiffArr[idx] = (int)(diff);
     }catch(Exception e){
         timeDiffArr[idx] = 0;
         msg("Error !!! Dis timestamp not a number ...");
     }       
 }
 private ProtocolDataUnit getPDU(Hashtable ht) {
     short pType = -1;
     ProtocolDataUnit aPdu = null;
     ProtocolDataUnit newPdu = null;
     DISHeaderDML disHeader;
     int disHeaderId = -1;
    // msg("Hash inside getPDU = ");
    // msg("inside getPDU id = " +ht.get("id").toString() + " type = "+ht.get("pdutype").toString()
     try {
         disHeaderId = Integer.parseInt(ht.get("id").toString());
         System.out.println("header id ="+disHeaderId);
     }catch(NumberFormatException e) {errMsg("getPDU(): Error while getting pdu header id !");msg(e.getMessage());}
     try {
         pType = Short.parseShort(ht.get("pdutype").toString());
     }catch(NumberFormatException e) {errMsg("getPDU(): Error while getting pdu type !");msg(e.getMessage());}
     try {
         if(pType < 0 ) errMsg("No pdutype present...!");
         System.out.println("PDU Type ="+pType);
         
         switch(pType) {
         
          // entity state pdu
         case PDUTypeField.ENTITYSTATE:
              EntityStatePduDML esPdu = new EntityStatePduDML(disHeaderId, entityId, db);
              newPdu = esPdu.getPDU();
              break;

         // Fire pdu
         case PDUTypeField.FIRE:
              FirePduDML fPdu = new FirePduDML(disHeaderId, db);
              newPdu = fPdu.getPDU();
              break;

         // Detonation pdu
         case PDUTypeField.DETONATION:
              DetonationPduDML dPdu = new DetonationPduDML(disHeaderId, db);
              newPdu = dPdu.getPDU();
              break;

   	  // Mine pdu
         case PDUTypeField.MINE:
              MinePduDML mPdu = new MinePduDML(disHeaderId, db);
              newPdu = mPdu.getPDU();
              break;

         // Minefield pdu
         case PDUTypeField.MINEFIELD:
              MinefieldPduDML mfPdu = new MinefieldPduDML(disHeaderId, db);
              newPdu = mfPdu.getPDU();
              break;  
	
         // Acknowledge pdu
         case PDUTypeField.ACKNOWLEDGE:
              AcknowledgePduDML ackPdu = new AcknowledgePduDML(disHeaderId, db);
              newPdu = ackPdu.getPDU();
              break;
	
         // StopFreeze pdu
         case PDUTypeField.STOPFREEZE:
              StopFreezePduDML sfPdu = new StopFreezePduDML(disHeaderId, db);
              newPdu = sfPdu.getPDU();
              break;

 	// StartResume pdu
         case PDUTypeField.STARTRESUME:
              StartResumePduDML srPdu = new StartResumePduDML(disHeaderId, db);
              newPdu = srPdu.getPDU();
              break;
 	
         default:
            {
                // unrecognized PDU type.
              System.out.print("Unrecognized PDU type received -");
              System.out.println(aPdu.getPduType().shortValue());
            }


         }
         disHeader = new DISHeaderDML(newPdu,ht,db);
         aPdu = disHeader.getPDU();
         if(aPdu == null ) errMsg("No pdu built from the header table...!");   
         PDUTypeField aPduTypeField = new PDUTypeField();
         msg("PDU Type = "+aPduTypeField.toString(aPdu.getPduType().shortValue()));
        //out.println("<br>"+aPduTypeField.toString(aPdu.getPduType().shortValue()) +"<br>");
     }catch(Exception e) {errMsg("Error while getting pdu type !");msg(e.getMessage());}
     return aPdu;
 } 
/**
 * Handle the POST HTTP REQUEST Method
 */

 public void doPost(HttpServletRequest req, HttpServletResponse res)
                    throws IOException {

     msg("Inside POST method ");
     out = res.getOutputStream();

     BufferedReader inpd = 
                new BufferedReader(new InputStreamReader(req.getInputStream()));
     String line;
     StringBuffer linebuf = new StringBuffer();
     while ((line = inpd.readLine()) != null) {
         if(!(line.startsWith("action"))) 
             linebuf.append(line+"\n");
         else
             getParams(line);  // one line with name=value attributes
     }
     msg(ht.toString());
     //db.close();
     out.println("Received all the input");
     out.close();
 }

/**
 *  Creates the DOM object and creates the PDU's
 */
 private void createPdus(String buf) {
 
     try{
         Freedom dom = new Freedom("com.docuverse.freedom.SAXDriver");
         dom.setProperty("sax.driver","com.microstar.xml.SAXDriver");

         StringReader sr = new StringReader(buf);
         Document doc = dom.openDocument(sr);

         readXML(doc);

      } catch( Exception mue)
        { 
        msg(mue.getMessage());
        System.out.println(" File is not readable! "); }
 }

 private int readXML(Document doc) {
      PDUTypeField aTypeField = new PDUTypeField();
      ProtocolDataUnit aPdu;
      int[] frequency = new int[256];
      int i=0;
      int ret=0, iret=0;
      printDOM aPrinter = new printDOM();

      for(i=0;i<256;i++) frequency[i]=0;

      System.out.println(" In readXML ");
      //pdu.insert(doc);
      //pdu.write(doc);
      //aPrinter.print(doc,"",System.out);
      System.out.println(" DOM is ready ");

      Element rNode = doc.getDocumentElement();

      if( rNode!=null )
      {
         NodeList aList = rNode.getElementsByTagName(DIS_TAGS.PDU);

         ret = aList.getLength();

         i=0;
         while( i<ret )
         {
           Node aNode = aList.item(i);
           if( aNode.getNodeName().equals(DIS_TAGS.PDU) )
           {
            aPdu = processANode((Element)aNode);
            if( aPdu!=null && aPdu.getPduType().shortValue()>-1 &&
                aPdu.getPduType().shortValue()<256 )
                { frequency[aPdu.getPduType().shortValue()]++; iret++; }
            if(action.equals("save")) 
				savePdu(aPdu);

          }// end of if

          i++;

        }// end of while

      }// end of if


      for(i=0;i<256;i++)
          if(frequency[i]>0)
             System.out.println(" F['"+aTypeField.toString(i)+"']: "+frequency[i ]);

      System.out.println(" There are "+iret+" pdus in the file! ");

      return ret;

}// end of readXML()

public static ProtocolDataUnit
   processANode(org.w3c.dom.Element aNode)
   {
      ProtocolDataUnit pdu = new EntityStatePdu();
      ProtocolDataUnit newPdu = null;

      org.w3c.dom.NodeList nodes = aNode.getElementsByTagName(iwt.DIS_TAGS.DIS_PDU_Header);
      if( nodes.getLength()<1 ) throw new InvalidDocumentType();

      org.w3c.dom.Node rt = nodes.item(0);
      pdu.extractHeader(rt);

      UnsignedByte pduType = pdu.getPduType();

      switch( pduType.shortValue() )
      {

         // entity state pdu
         case PDUTypeField.ENTITYSTATE:
              newPdu = new EntityStatePdu();
              //System.out.println(" PduType : EntityState");
              newPdu.extract(aNode);
              break;

         // Fire pdu
         case PDUTypeField.FIRE:
              newPdu = new FirePdu();
              newPdu.extract(aNode);
              break;

        // detonation PDU, the fire PDU's frequent companion.
        case PDUTypeField.DETONATION:
             if(DEBUG)
                System.out.println("got a packet, instantiating a DETONATATION PDU");
             newPdu = new DetonationPdu();
             newPdu.extract(aNode);
             break;
        // Message PDU, same as CommentPDU, I THINK.
        case PDUTypeField.MESSAGE:
             if(DEBUG) System.out.println("got a message PDU");
             newPdu = new CommentPdu();
             newPdu.extract(aNode);
             break;

        // Acknowledge PDU
        case PDUTypeField.ACKNOWLEDGE:
             if(DEBUG) System.out.println("got a ACKNOWLEDGE PDU");
             newPdu = new AcknowledgePdu();
             newPdu.extract(aNode);
             break;

        // ActionRequest PDU
        case PDUTypeField.ACTIONREQUEST:
             if(DEBUG) System.out.println("got a ActionRequest PDU");
             newPdu = new ActionRequestPdu();
             newPdu.extract(aNode);
             break;

        // ActionResponse PDU
        case PDUTypeField.ACTIONRESPONSE:
             if(DEBUG) System.out.println("got a ActionResponse PDU");
             newPdu = new ActionResponsePdu();
             newPdu.extract(aNode);
             break;

        // CreateEntity PDU
        case PDUTypeField.CREATEENTITY:
             if(DEBUG) System.out.println("got a CreateEntity PDU");
             newPdu = new CreateEntityPdu();
             newPdu.extract(aNode);
             break;
   // Data PDU
        case PDUTypeField.DATA:
             if(DEBUG) System.out.println("got a Data PDU");
             newPdu = new DataPdu();
             newPdu.extract(aNode);
             break;

        // DataQuery PDU
        case PDUTypeField.DATAQUERY:
             if(DEBUG) System.out.println("got a DataQuery PDU");
             newPdu = new DataQueryPdu();
             newPdu.extract(aNode);
             break;

        // EventReport PDU
        case PDUTypeField.EVENTREPORT:
             if(DEBUG) System.out.println("got a EventReport PDU");
             newPdu = new EventReportPdu();
             newPdu.extract(aNode);
             break;

        // RemoveEntity PDU
        case PDUTypeField.REMOVEENTITY:
             if(DEBUG) System.out.println("got a RemoveEntity PDU");
             newPdu = new RemoveEntityPdu();
             newPdu.extract(aNode);
             break;

        // SetData PDU
        case PDUTypeField.SETDATA:
             if(DEBUG) System.out.println("got a SetData PDU");
             newPdu = new SetDataPdu();
             newPdu.extract(aNode);
             break;

        // StartResume PDU
        case PDUTypeField.STARTRESUME:
         if(DEBUG) System.out.println("got a StartResume PDU");
             newPdu = new StartResumePdu();
             newPdu.extract(aNode);
             break;

        // StopFreeze PDU
        case PDUTypeField.STOPFREEZE:
             if(DEBUG) System.out.println("got a StopFreeze PDU");
             newPdu = new StopFreezePdu();
             newPdu.extract(aNode);
             break;

        /*
        // SimulationManagement PDU
        case PDUTypeField.SETDATA:
                if(DEBUG)
            System.out.println("got a SimulationManagement PDU");
            newPdu = new SimulationManagementPdu();
            ((SimulationManagementPdu)newPdu).deSerialize(new DataInputStream(pS
tream));
            break;
        */

        //case PDUTypeField.COLLISION:           return; // do collision pdu here^M


        default:
            {
                // unrecognized PDU type.
              System.out.print("Unrecognized PDU type received in packet:");
              System.out.println(pduType.shortValue());
            }

      }// end of switch()

      PDUTypeField aTypeField = new PDUTypeField();
   if(newPdu!=null) 
   System.out.println(" PduType : "+aTypeField.toString(pduType.shortValue ()));

      return newPdu;

   }// end of processANode()

/**
 * Saves the PDU data into the database
 */
 private void savePdu(ProtocolDataUnit aPdu) { 
     DISHeaderDML disHeader; 
     int disHeaderId = -1;

     if( aPdu!=null && aPdu.getPduType().shortValue()>-1 &&
                aPdu.getPduType().shortValue()<256 ){
         msg("Before the switch statement");
         disHeader = new DISHeaderDML(aPdu,db);
         disHeader.save();
         disHeaderId = disHeader.getId();

         switch(aPdu.getPduType().shortValue()) {
         
          // entity state pdu
         case PDUTypeField.ENTITYSTATE:
              EntityStatePduDML esPdu = new EntityStatePduDML((EntityStatePdu)aPdu, disHeaderId, db);
              esPdu.save();
              break;

         // Fire pdu
         case PDUTypeField.FIRE:
              break;

         default:
            {
                // unrecognized PDU type.
              System.out.print("Unrecognized PDU type received -");
              System.out.println(aPdu.getPduType().shortValue());
            }


         }
         //msg("PDU Type = "+aPduTypeField.toString(aPdu.getPduType().shortValue()));
     }

 }


/***************************************************
 *  Gets all the parameters from the request
 **************************************************/   
 private void getParams(String str) {

       ht = HttpUtils.parseQueryString(str);
       action = ht.get("action").toString();
 }

/**
 * Initialize the servlet, DB connection etc.
 */

 public void init(ServletConfig config) throws ServletException {
     super.init(config);
     db = new SQLUtil();
     db.open();
 }

/**
 * Clean up the servlet at the very end
 */
 
 public void destroy() {
     db.close();
 }
 private void errMsg(String str) {
     try{
     out.println("<html><title> DISPduPlaybackServlet Page </title>");
     out.println("<body bgcolor=white>");
     out.println(str);
     out.println("</body></html>");
     out.flush();
     out.close();
     }catch(IOException e) {msg("Error while printing error message !" + e.getMessage());}
     msg(str);
 }
 private void msg(String str) {
     System.out.println(str);
 }

}

