/**
 * Query Class
 */

package pduDB;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.*;

import mil.navy.nps.dis.*;
import mil.navy.nps.util.*;
import mil.navy.nps.disEnumerations.*;

import org.w3c.dom.*; 
import com.docuverse.freedom.*;

import iwt.domUtil.*;
import iwt.*;
public class DISPduQuery {

 private String sql = "";

 public DISPduQuery(String s){
     sql = s;
     doQuery (sql);
 }

 private void doQuery(String sql ) {

     Hashtable rht = new Hashtable();
     //Vector pduVec = new Vector();
     //ProtocolDataUnit aPdu = null;
     int i = 0,total =0;
     PduSender pduSender;
     msg("going to check the mode ="+ mode);
     if(mode.equals("hla")) {
         pduSender = new HLAPduSender();
         msg("Sending in HLA mode ");
     }
     else {
         pduSender = new DISPduSender();
         msg("Sending in DIS mode ");
     }

     

     Vector v = db.getMultiRecords(sql);
     total = v.size();
     htArr = new Hashtable[total];
     timeDiffArr = new int[total];

     msg("Vector size = "+total);
     
     for (Enumeration e = v.elements() ; e.hasMoreElements() ;) {
         htArr[i] = (Hashtable)e.nextElement();
          i++;
     }
  //   timeDiffArr[0] = 0;
     ProtocolDataUnit sPdu;
     short j = 0;
     for(i=0; i<htArr.length;i++) {
       // j = Short.parseShort(htArr[i].get("pdutype").toString());
        //if(j == 1 || j == 175 || j == 176 || j == 2 || j == 3 ) {
            
            if( i < total-1 ) 
                 setTimeDiffArr(i,htArr[i].get("distimestamp").toString(),
                     htArr[i+1].get("distimestamp").toString());
            sPdu = getPDU(htArr[i]);
            if(i <= timeDiffArr.length)
                try { Thread.sleep(timeDiffArr[i]);}catch(Exception e){}
            //j = sPdu.getPduType().shortValue();
            if(sendingFlag) {
                pduSender.send(sPdu);
            }else{
                pduSender.stop();
                break;
            }
       //  }
         System.out.println("sending pdu # "+i + " after "+timeDiffArr[i] + " seconds");
     }
     msg("Finished setting their times");
     
     msg("Finished producing PDU's.........");
  //   try {
    // out.println("Send "+total + " # of PDU's");
     //}catch(Exception e){msg("could not write to socket");}
    
 }
 private void setTimeDiffArr(int idx,String t1, String t2) {
     int time1, time2, diff = 0;
     try {
         time1 = Integer.parseInt(t1);
         time2 = Integer.parseInt(t2);
       //  System.out.println("i="+idx+"time1="+time1+" time2="+time2);
         diff = time2 - time1;
         if(diff < 0) {
             diff = 0;
         }else if (diff > 999) {
             diff = 500;
         }
         System.out.println("diff = "+diff);
         if(mode.equals("hla")) diff = diff +1000;
         timeDiffArr[idx] = (int)(diff);
     }catch(Exception e){
         timeDiffArr[idx] = 0;
         msg("Error !!! Dis timestamp not a number ...");
     }       
 }
 private ProtocolDataUnit getPDU(Hashtable ht) {
     short pType = -1;
     ProtocolDataUnit aPdu = null;
     ProtocolDataUnit newPdu = null;
     DISHeaderDML disHeader;
     int disHeaderId = -1;
    // msg("Hash inside getPDU = ");
    // msg("inside getPDU id = " +ht.get("id").toString() + " type = "+ht.get("pdutype").toString()
     try {
         disHeaderId = Integer.parseInt(ht.get("id").toString());
         System.out.println("header id ="+disHeaderId);
     }catch(NumberFormatException e) {errMsg("getPDU(): Error while getting pdu header id !");msg(e.getMessage());}
     try {
         pType = Short.parseShort(ht.get("pdutype").toString());
     }catch(NumberFormatException e) {errMsg("getPDU(): Error while getting pdu type !");msg(e.getMessage());}
     try {
         if(pType < 0 ) errMsg("No pdutype present...!");
         System.out.println("PDU Type ="+pType);
         
         switch(pType) {
         
          // entity state pdu
         case PDUTypeField.ENTITYSTATE:
              EntityStatePduDML esPdu = new EntityStatePduDML(disHeaderId, entityId, db);
              newPdu = esPdu.getPDU();
              break;

         // Fire pdu
         case PDUTypeField.FIRE:
              FirePduDML fPdu = new FirePduDML(disHeaderId, db);
              newPdu = fPdu.getPDU();
              break;

         // Detonation pdu
         case PDUTypeField.DETONATION:
              DetonationPduDML dPdu = new DetonationPduDML(disHeaderId, db);
              newPdu = dPdu.getPDU();
              break;

   	  // Mine pdu
         case PDUTypeField.MINE:
              MinePduDML mPdu = new MinePduDML(disHeaderId, db);
              newPdu = mPdu.getPDU();
              break;

         // Minefield pdu
         case PDUTypeField.MINEFIELD:
              MinefieldPduDML mfPdu = new MinefieldPduDML(disHeaderId, db);
              newPdu = mfPdu.getPDU();
              break;  
	
         // Acknowledge pdu
         case PDUTypeField.ACKNOWLEDGE:
              AcknowledgePduDML ackPdu = new AcknowledgePduDML(disHeaderId, db);
              newPdu = ackPdu.getPDU();
              break;
	
         // StopFreeze pdu
         case PDUTypeField.STOPFREEZE:
              StopFreezePduDML sfPdu = new StopFreezePduDML(disHeaderId, db);
              newPdu = sfPdu.getPDU();
              break;

 	// StartResume pdu
         case PDUTypeField.STARTRESUME:
              StartResumePduDML srPdu = new StartResumePduDML(disHeaderId, db);
              newPdu = srPdu.getPDU();
              break;
 	
         default:
            {
                // unrecognized PDU type.
              System.out.print("Unrecognized PDU type received -");
              System.out.println(aPdu.getPduType().shortValue());
            }


         }
         disHeader = new DISHeaderDML(newPdu,ht,db);
         aPdu = disHeader.getPDU();
         if(aPdu == null ) errMsg("No pdu built from the header table...!");   
         PDUTypeField aPduTypeField = new PDUTypeField();
         msg("PDU Type = "+aPduTypeField.toString(aPdu.getPduType().shortValue()));
        //out.println("<br>"+aPduTypeField.toString(aPdu.getPduType().shortValue()) +"<br>");
     }catch(Exception e) {errMsg("Error while getting pdu type !");msg(e.getMessage());}
     return aPdu;
 } 
 
 private void msg(String msg) {
     System.out.println(msg);
 }
}