/**
 * MultiCastPduSender.java
 *
 */
package pduDB;

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

import mil.navy.nps.dis.*;
import mil.navy.nps.disEnumerations.*;
import jdis.*;

import comm.MulticastPDUPublisher;

public class DISPduSender implements PduSender {

 String  mCastAddress   = JDISConstants.DEFAULT_MCAST;
 int     gPortNumber    = JDISConstants.DEFAULT_MPORT;   
     
 int     collectUdpPort = JDISConstants.DEFAULT_COLLECTUDPPORT;         
 int     nPortNumber    = JDISConstants.DEFAULT_SERVER_PORT;        
 String  nServer        = JDISConstants.DEFAULT_SERVER; 

 MulticastSocket socket;
 InetAddress     igroup;

 PDUPublisher  disPublisher = null;

 ProtocolDataUnit [] pduArr;

 public DISPduSender() {
    try {
        pduArr = null;
	disPublisher = new MulticastPDUPublisher(mCastAddress,gPortNumber);
        disPublisher.startPublishing();
    }catch( Exception e) {msg(e.getMessage());e.printStackTrace(System.out);}
 }
 
 public DISPduSender(ProtocolDataUnit [] pdus) {
    try {
        pduArr = pdus;
	disPublisher = new MulticastPDUPublisher(mCastAddress,gPortNumber);
        disPublisher.startPublishing();
    }catch( Exception e) {msg(e.getMessage());e.printStackTrace(System.out);}
 }

 public void send(ProtocolDataUnit pdu) {
    disPublisher.send(pdu);
 }

 public void send(){
     PDUTypeField aTypeField = new PDUTypeField();
     //
      int[] frequency = new int[256];
      int i = 0;
      for(i=0;i<256;i++) frequency[i]=0;
      int numOfPdus = 0;

     //test
//     for (Enumeration e = pduVec.elements() ; e.hasMoreElements() ;) {
//         aPdu = (ProtocolDataUnit)e.nextElement();
     for(i=0; i<pduArr.length; i++) { 
         disPublisher.send(pduArr[i]);
         frequency[pduArr[i].getPduType().shortValue()]++;
         numOfPdus++;
     }
     System.out.println(" There are "+numOfPdus+" pdus in the file! ");
     for(i=0;i<256;i++)
     if(frequency[i]>0) System.out.println(aTypeField.toString(i)+" = F["+i+"] : "+frequency[i]);
   
 }
 public void stop(){
     if(disPublisher != null) disPublisher.closeConnection();
 }
 private void msg(String str) {
     System.out.println(str);
 }
}