/**
 * HLAPduSender.java
 *
 */
package pduDB;

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

import mil.navy.nps.dis.*;
import mil.navy.nps.disEnumerations.*;
import jdis.*;

import comm.DISHLAPublisher;
import comm.DISHLASubscriberAdmin;

public class HLAPduSender implements PduSender {
      
 int     nPortNumber    = JDISConstants.DEFAULT_SERVER_PORT;   //hardcoded below
 String  nServer        = JDISConstants.DEFAULT_SERVER; 

 MulticastSocket socket;
 InetAddress     igroup;

 PDUPublisher  hlaPublisher = null;
 SubscriberAdmin  hlaSubAdmin = null;

 
 ProtocolDataUnit [] pduArr;

 public HLAPduSender() {
    pduArr = null;
    setProtocols();
 }
 
 public HLAPduSender(ProtocolDataUnit [] pdus) {
     pduArr = pdus;
     setProtocols();
 }

 private  void setProtocols(){
     try {
        System.out.println("#####hardcoded inside HLAPdu sender server="+nServer +" port= "+nPortNumber);
	hlaPublisher = new DISHLAPublisher(nServer,nPortNumber);
        hlaSubAdmin = new DISHLASubscriberAdmin();
        ((DISHLASubscriberAdmin)hlaSubAdmin).setBoss((DISHLAPublisher)hlaPublisher);
      // ((DISHLAPublisher)hlaPublisher).startPublishing((RTIcap.FederateAmbassador)hlaSubAdmin);
        ((DISHLAPublisher)hlaPublisher).startPublishing();

     }catch( Exception e) {msg(e.getMessage());e.printStackTrace(System.out);}

 }

 public void send(ProtocolDataUnit pdu) {
    hlaPublisher.send(pdu);
 }

 public void send(){
     PDUTypeField aTypeField = new PDUTypeField();
     //
      int[] frequency = new int[256];
      int i = 0;
      for(i=0;i<256;i++) frequency[i]=0;
      int numOfPdus = 0;

     //test
//     for (Enumeration e = pduVec.elements() ; e.hasMoreElements() ;) {
//         aPdu = (ProtocolDataUnit)e.nextElement();
     for(i=0; i<pduArr.length; i++) { 
         hlaPublisher.send(pduArr[i]);
         frequency[pduArr[i].getPduType().shortValue()]++;
         numOfPdus++;
     }
     System.out.println(" There are "+numOfPdus+" pdus in the file! ");
     for(i=0;i<256;i++)
     if(frequency[i]>0) System.out.println(aTypeField.toString(i)+" = F["+i+"] : "+frequency[i]);
   
 }
 public void stop(){
     if(hlaPublisher != null) hlaPublisher.closeConnection();
 }
 private void msg(String str) {
     System.out.println(str);
 }
}