/**
 * SQLUtil.java
 *
 * This class has all the database related methods including
 * opening and closing the connection, querying etc.
 */
package pduDB;

import java.sql.*;
import java.util.*;
import java.math.*;


public class SQLUtil {

 private static Connection con;

 public SQLUtil() {
     con = null;
 }

 public SQLUtil(Connection c) {
     con = c;
 }
/*********************************************************
 * insert a record to the table specified
 **********************************************************/
 public synchronized int insert(Hashtable ht, String tablename,
			String sql, int mask) {
     String tmpsql = "select * from "+tablename ; //+" where rownum < 2";
     String val = "";

     PreparedStatement pstmt;

     try {
      if(!isOpen()) connect();
      pstmt = con.prepareStatement(sql);
      Statement stmt = con.createStatement();
      stmt.execute(tmpsql);
      ResultSet rs = stmt.getResultSet();
      ResultSetMetaData rsmd = rs.getMetaData();
      int colcnt = rsmd.getColumnCount();
      //msg("Col cnt for the table "+ tablename +"  = "+colcnt);
     // msg("ht before preparation="+ht.toString());
      for(int i=1; i <= colcnt; i++ ) {
          if(i != mask) {   
              //msg("i val="+i+"ht="+ ht.toString()+"name = "+rsmd.getColumnName(i).toLowerCase());   
              val = (String)ht.get((rsmd.getColumnName(i)).toLowerCase());
             // System.out.print("##type="+rsmd.getColumnType(i)+" name="+(rsmd.getColumnName(i)).toLowerCase()+"="+ val+"##\t");
              if(isNull(val)) {
                  pstmt = setPreparedStatementValue(i,null,rsmd.getColumnType(i),mask,pstmt);
              }else {
                  pstmt = setPreparedStatementValue(i,val,rsmd.getColumnType(i),mask,pstmt);
              }
              
          }
      }
     // System.out.println("Just before executing the prepared statement");
     // msg("SQL="+sql); 
      rs.close();
      stmt.close();
       } catch (SQLException e) {
      msg("Error after setting the prepared statement code=" + e.getErrorCode());
      msg("### "+ht.toString() + "## = "+e.getSQLState());
      System.out.println(e.getMessage() + " @@@@error stack"); 
      e.printStackTrace(System.out);       
      return -1;
     }catch (Exception ge) {
      msg("Error after setting the prepared statement code=");
      msg("### "+ht.toString() + "## = ");
      System.out.println(ge.getMessage() + " @@@@error stack"); 
      ge.printStackTrace(System.out);       
      return -1;
     }try {
      pstmt.executeUpdate();
      pstmt.close();
     // rsmd = null;
     // stmt = null;
      pstmt = null;
    //  close();
      return 1;
     } catch (SQLException e) {
      msg("Error while executing the prepared statement code=" + e.getErrorCode());
      msg("### "+ht.toString() + "## = "+e.getSQLState());
      System.out.println(e.getMessage() + " @@@@error stack"); 
      e.printStackTrace(System.out);       
      return -1;
     }catch (Exception ge) {
      msg("Error while executing the prepared statement code=");
      msg("### "+ht.toString() + "## = ");
      System.out.println(ge.getMessage() + " @@@@error stack"); 
      ge.printStackTrace(System.out);       
      return -1;
     }
 }
/**
 * Sets appropriate values for the prepared statement including
 * nulls etc.
 */
 private synchronized PreparedStatement setPreparedStatementValue(int num, 
          String val, int datatype,int mask, PreparedStatement ptmt)
		      throws SQLException{
     int col = num;
     if( mask != 0 && mask < num) { col = col -1 ;}
     //msg("col inside set Insert = "+col);

     switch(datatype) {
     case Types.DATE:
         ptmt.setNull(col,Types.DATE);
         //java.sql.Date date = rs.getDate(col);
         //value = date.toString();
         break;
     case Types.TIME:
         ptmt.setNull(col,Types.TIME);
         //java.sql.Time time = rs.getTime(col);
         //value = time.toString();
         break;
     case Types.TIMESTAMP:
         ptmt.setNull(col,Types.TIMESTAMP);
         // java.sql.Timestamp timestamp = rs.getTimestamp(col);
         //     value = timestamp.toString();
         break;
     case Types.CHAR:
     case Types.VARCHAR:
     case Types.LONGVARCHAR:
         //System.out.println("Came inside varchar val ="+val + "@@");
         if(val == null) {
             ptmt.setNull(col,Types.VARCHAR);
         }else {
             ptmt.setString(col,val);
         }
         //    value = rs.getString(col);
         break;
     case Types.NUMERIC:
     case Types.DECIMAL:
         if(isNull(val)) {
             ptmt.setNull(col,Types.NUMERIC);
         }else {
             ptmt.setBigDecimal(col,(new BigDecimal(val)));
         }
         // java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
         // value = numeric.toString();
         break;
/*
    case Types.BIT:
    //  boolean bit = rs.getBoolean(col);
     // value = (new Boolean(bit)).toString();

      break;
    case Types.TINYINT:
      byte tinyint = rs.getByte(col);
      value = (new Byte(tinyint)).toString();
      break;
     //case Types.SMALLINT:
     //      short smallint = rs.getShort(col);
     //    value = (new Short(smallint)).toString();
    //  break;
    //int shrval = (new (val)).intValue();
*/

     case Types.SMALLINT:
     case Types.INTEGER:
         int intval = (new Integer(val)).intValue();
         if(isNull(val)) {
             ptmt.setNull(col,Types.INTEGER);
         }else {
             ptmt.setInt(col, intval);
         }
         // int integer = rs.getInt(col);
         //Integer ind = new Integer(integer);
         //value = ind.toString();
         break;

     case Types.BIGINT:
         long lval = (new Long (val)).longValue();
         if(isNull(val)) {
             ptmt.setNull(col,Types.BIGINT);
         }else {
             ptmt.setLong(col, lval);
         }

         // long bigint = rs.getLong(col);
         // Long lng = new Long (bigint);
         // value =  lng.toString();
         break;
/*
    case Types.REAL:
      float real = rs.getFloat(col);
      value = (new Float(real)).toString();
      break;
    case Types.FLOAT:
    case Types.DOUBLE:
      double longreal = rs.getDouble(col);
      value = (new Double(longreal)).toString();
      break;
    case Types.BINARY:
    case Types.VARBINARY:
    case Types.LONGVARBINARY:
      byte[] binary = rs.getBytes(col);
      value = new String(binary);
      break;

*/
    }
     return ptmt;
 }

/**
 * This method returns the maximum value of a field in a table
 */
 public synchronized String getMaxValue(String tablename, String fieldname) {
     String sql = "select MAX("+fieldname+") from "+tablename ;
     Hashtable ht = getRecord(sql);
     Enumeration e = ht.elements();
     String tmpstr = (String)e.nextElement();
     e = null;ht = null;
     //System.out.println("Max value = "+tmpstr);
     return tmpstr;
 }
/** 
 * This method retrieves a single row and returns the record as a
 * Hashtable
 */

 public Hashtable getRecord(String sql) {
     Hashtable ht = new Hashtable();
     try {
         if(!isOpen()) connect();
         Statement stmt = con.createStatement();
         stmt.execute(sql);
         ResultSet rs = stmt.getResultSet();
         ResultSetMetaData rsmd = rs.getMetaData();
         int colcnt = rsmd.getColumnCount();
         while (rs.next()) {
             for(int i =1; i <= colcnt; i++) {
                 ht.put((rsmd.getColumnName(i)).toLowerCase(),
                     getValue(rs,rsmd.getColumnType(i),i));
             }
         }
         rs.close();
         stmt.close();
         //System.out.println("SQL="+sql);
         //System.out.println("result="+ht);
     }catch(Exception e) {
         System.out.println("Cannot execute SQL "+ e.getMessage());
     }
     return ht;
 }

/**
 * This method returns a Vector of Hashtables of the result of the query
 * essentially returns multiple records
 */
 public Vector getMultiRecords(String sql){
     Vector v  = new Vector();
     Hashtable ht ; 
     try {
         if(!isOpen()) connect();
         Statement stmt = con.createStatement();
         stmt.execute(sql);
         ResultSet rs = stmt.getResultSet();
         ResultSetMetaData rsmd = rs.getMetaData();
         int colcnt = rsmd.getColumnCount();
         while (rs.next()) {
             ht = new Hashtable();
             for(int i =1; i <= colcnt; i++) {
                 ht.put((rsmd.getColumnName(i)).toLowerCase(),
                     getValue(rs,rsmd.getColumnType(i),i));
             }
             v.addElement(ht);
         }
         rs.close();
         stmt.close();
         //System.out.println("SQL="+sql);
         //System.out.println("result="+ht);
     }catch(Exception e) {
         System.out.println("Cannot execute SQL "+ e.getMessage());
     }
     return v;
}

/**
 * Returns the appropriate value/type from the result set
 *
 */
 private String getValue(ResultSet rs, int datatype, int col)
      throws SQLException{

     String value="";
     if(rs == null) { System.out.println("Empty Result Set");}

     switch(datatype) {
     case Types.DATE:
       java.sql.Date date = rs.getDate(col);
       value = date.toString();
       break;
     case Types.TIME:
       java.sql.Time time = rs.getTime(col);
       value = time.toString();
       break;
     case Types.TIMESTAMP:
       java.sql.Timestamp timestamp = rs.getTimestamp(col);
       value = " ";
       break;
     case Types.CHAR:
     case Types.VARCHAR:
     case Types.LONGVARCHAR:
       value = rs.getString(col);
       break;
     case Types.NUMERIC:
     case Types.DECIMAL:
       java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
       value = numeric.toString();
       break;
     case Types.BIT:
       boolean bit = rs.getBoolean(col);
       value = (new Boolean(bit)).toString();
       break;
     case Types.TINYINT:
       byte tinyint = rs.getByte(col);
       value = (new Byte(tinyint)).toString();
       break;
     case Types.SMALLINT:
       short smallint = rs.getShort(col);
       value = (new Short(smallint)).toString();
       break;
     case Types.INTEGER:
       int integer = rs.getInt(col);
       Integer ind = new Integer(integer);
       value = ind.toString();
       break;

     case Types.BIGINT:
       long bigint = rs.getLong(col);
       Long lng = new Long (bigint);
       value =  lng.toString();
       break;
     case Types.REAL:
       float real = rs.getFloat(col);
       value = (new Float(real)).toString();
       break;
     case Types.FLOAT:
     case Types.DOUBLE:
       double longreal = rs.getDouble(col);
       value = (new Double(longreal)).toString();
       break;
     case Types.BINARY:
     case Types.VARBINARY:
     case Types.LONGVARBINARY:
       byte[] binary = rs.getBytes(col);
       value = new String(binary);
       break;

     }
     if (value == null ) 
         value = "";
     return value;
 }

/*********************************************
 *
 *********************************************/
 private boolean isNull(String s){
     if(s.trim().equalsIgnoreCase(""))
         return true;
     else return false;
 }

/*********************************************************
 * Connect to the database 
 *********************************************************/
 private void connect() {
     if(con == null) {
        System.out.println("connect is called and con is null");
        try {
       //  Class.forName("weblogic.jdbc.oci.Driver");
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        // Class.forName( "symantec.itools.db.jdbc.Driver" );
         System.out.println("Loaded driver class ");
         con = DriverManager.getConnection("jdbc:odbc:pdudsn");
         //con = DriverManager.getConnection("jdbc:dbaw://localhost:1433/SQL Server/SQL Server/pdudsn",
                                        //   "tapulika","tom");
         System.out.println("Connected to DB ");
        }catch(Exception e) {
         System.out.println(e.getMessage()); }
     }else {System.out.println("Using same connection"); }
 }

/**
 * Disconnect from the database
 */
 private void disconnect() {
     if(con != null) {
         try { con.close(); con = null;}
         catch (SQLException e) {System.out.println("Error while closing connection"+e.getMessage()); }
     }
 }

/**
 * Open database connection 
 */
 public void open() {
     connect();
 }

/**
 * Close database connection 
 */
 public void close () {
     disconnect();
 }

/**
 * Is the connection still open 
 */
 public boolean isOpen() {
     if(con == null ) return false;
     else return true;
 }
 
 private void msg(String str) {
     System.out.println(str);
 }

}
