/**
*/
package pduDB;

import java.net.*;
import java.io.*;

import mil.navy.nps.dis.*;
import mil.navy.nps.util.*;
import mil.navy.nps.disEnumerations.*;

import org.w3c.dom.*;
import com.docuverse.freedom.*;

import iwt.domUtil.*;
import iwt.*;

import PDUReadWrite;

/**
*
* Reeads the PDU input file and produces the frequency information about
* each type of pdu and total number of pdus in the file.
*
* @author H. Timucin Ozdemir
* @date   October 19, 1998 (Last Updated October 22, 1998)
*
*/
public class printXML
{

   /**
   */
   public static void
   writeXML(ProtocolDataUnit pdu)
   {

      String header = "<?XML version=\"1.0\"?>"+"\n"+
                      "<!DOCTYPE DIS_F SYSTEM \"DIS.dtd\">";
      System.out.println(" In writeXML ");
      Document doc = new FreedomDocument();
      //pdu.insert(doc);

      pdu.write(doc);

      printDOM aPrinter = new printDOM();
      aPrinter.print(doc,header,System.out);
      System.out.println(" DOM is ready ");

   }// end of writeXML()

   /**
   */
   public static void
//   read( String fileName, String oFilename )
     read(InputStream fin, String oFilename)
   {

      boolean headerIsPrinted=false;
      int i=0;
      int[] frequency = new int[256];

      for(i=0;i<256;i++) frequency[i]=0;

      String header = "<?XML version=\"1.0\"?>"+"\n"+
                      "<!DOCTYPE DIS_F SYSTEM \"DIS.dtd\">";

      Document doc = new FreedomDocument();
      Element  ele = doc.createElement(DIS_TAGS.PDUS);
      doc.appendChild(ele);

      try
      {
//        FileInputStream fin = new FileInputStream(fileName);
        PrintStream     fout = new PrintStream(new FileOutputStream(oFilename));
        int limit=100,k=0;
        int a;

        PushbackInputStream in = new  PushbackInputStream(fin,30);

        ProtocolDataUnit pdu = null;
        int numOfPdus = 0;

        do
        {
          // Read one PDU
          pdu = PDUReadWrite.getPDU(in);
    
          if(pdu!=null) 
          {    
             System.out.println(" PDU Type: "+pdu.getPduType());
             numOfPdus++;

             // Update Frequency 
             frequency[pdu.getPduType().shortValue()]++;

             // Write to Document
             pdu.insert(ele);

          }// end of if

        } while(pdu!=null);

        System.out.println(" There are "+numOfPdus+" pdus in the file! ");
        for(i=0;i<256;i++)
         if(frequency[i]>0) System.out.println("F["+i+"] : "+frequency[i]);

        // Print Document 
        printDOM aPrinter = new printDOM();
        aPrinter.print(doc,header,fout);

      } catch(java.io.FileNotFoundException fnf) {}
        catch(java.io.IOException ioe) {}

   }// end of main

   public printXML(String str) {
       System.out.println("printXML called");
       StringBufferInputStream sbip = new StringBufferInputStream(str);
       String ofileName = "pdustest.xml";
       read(sbip,ofileName);
   }
   /**
   */
   public static void
   main(String[] args)
   {
      String fileName = "in.pdu";
      String ofileName = "pdus.xml";
      int i=0;
      int[] frequency = new int[256];
      boolean giveHelp=false;

      while(i<args.length)
      {
        if( args[i].equals("-ifile") && i<(args.length-1) )
            fileName =  args[++i];
        if( args[i].equals("-ofile") && i<(args.length-1) )
            ofileName =  args[++i];
        else if( args[i].equals("-help") ) giveHelp=true;
        i++;
      }// end of while

      if(giveHelp)
      {
        System.out.println();
        System.out.println(" java printXML [-ifile <filename>] [-ofile <filename>] [-help] ");
        System.out.println("   ifile : gives the name of pdu input file.(default in.pdu) ");
        System.out.println("   ofile : gives the name of output file.(default pdus.xml) ");
        System.out.println("    help : ? ");
        System.out.println(" purpose : Reads the PDU info from file and produces XML version of it. ");
        System.out.println();
      }
      //else printXML.read(fileName,ofileName);
      
   }// end of main

}// end of printXML()
